# Debug is not properly generated and we don't need it anyway here
%define	_enable_debug_packages %{nil}
%define	debug_package %{nil}

%define	build_optimization 0
%{?_with_optimization: %{expand: %%global build_optimization 1}}

Summary:	An arcade emulator
Name:		raine
Version:	0.91.15b
Release:	%mkrel 1
License:	Freeware
Packager: 	Agent Smith <ruidobranco@yahoo.com.br>
Group:		Emulators
Url:		http://raine.1emulation.com/
Source0:	%{name}-%{version}.tar.gz
Source1:	icons.zip
Source2:	rainedocs.zip
Source3:	http://raine.1emulation.com/archive/command.7z
Source5:	shots.pl
Source6:	raine-neocd-cheats.tar.gz
Source7:	http://raine.1emulation.com/archive/hiscore-211.7z
Source8:	raine-fonts.tar.bz2
Source9:	raine-bitmaps.tar.bz2
Source10:	http://raine.1emulation.com/archive/history-%{name}-2.11.7z
Source11:	http://raine.1emulation.com/archive/blend_201501.7z
Source20:	%{name}.rpmlintrc
Patch0:		raine-0.91.10-makefile-libs.patch

# emudx sources from : http://raine.1emulation.com/download/extras.html
# to add an emudx file :
# add its basename to the emudx_sources list below 
%define emudx_sources "dkongg dkongm froggerg froggerm galdxg galdxm\
 mspacmang pacmang"
#mspacmanm pacmanm
# this generates Source1xx tags (400 max)
%(echo %{emudx_sources} | awk 'BEGIN { RS=" "; n=0 }; { print "Source"100+n":\t"$1".dx2"; n++ };')
# this generates the list of emudx files for the install step
%define emudx_files %(echo %{emudx_sources} | awk 'BEGIN { RS=" "; files="" }; { files=files" %{_sourcedir}/"$1".dx2"}; END { print files };')

# artwork sources from : http://raine.1emulation.com/download/extras.html
# to add an artwork archive :
# add its basename to the artwork_sources list below
%define artwork_sources "1941 19xx arbalest arkanoid arknoid2 batrider\
 bjtwin block darius2 ddonpach dfeveron dkong dogyuun donpachi downtown\
 driftout extrmatn fireshrk frogger ghoulsu gunbird majest12 matmania\
 mercs msh mspacman msword ninjaw outzone pacman pacplus pengo puckman\
 s1945 sf2ce slammast ssi superman tdragon terracre thunderl tknight\
 tndrcade varth vimana warriorb xmcota"
# this generates Source5xx tags
%(echo %{artwork_sources} | awk 'BEGIN { RS=" "; n=0 }; { print "Source"500+n":\t"$1".zip"; n++ };')
# this generates the list of artwork files for the install step
%define artwork_files %(echo %{artwork_sources} | awk 'BEGIN { RS=" "; files="" }; { files=files" %{_sourcedir}/"$1".zip"}; END { print files };')

BuildRequires:	desktop-file-utils
BuildRequires:	nasm
BuildRequires:	p7zip
BuildRequires:	lib64SDL_sound-devel
BuildRequires:	lib64smpeg-devel
# for the converter
BuildRequires:	lib64allegro4-devel
BuildRequires:	lib64flac++6-devel
# the rest
BuildRequires:	lib64glew-devel
BuildRequires:	lib64mesaglu1-devel
BuildRequires:	lib64curl-devel
BuildRequires:	lib64mikmod-devel
BuildRequires:	lib64png1.6-devel
BuildRequires:	lib64muparser-devel
BuildRequires:	lib64ogg-devel
BuildRequires:	lib64SDL-devel
BuildRequires:	lib64SDL_image-devel
BuildRequires:	lib64SDL_ttf-devel
BuildRequires:	lib64vorbis0-devel

%rename	%{name}-neocd
Provides:	neoraine = %{version}
# For the shots script
Requires:	wget

%description
Raine is an emulator, it emulates some M68000 and M68020 arcade games and is
mainly focused on Taito and Jaleco games hardware. Since 0.62 Raine was merged
with NeoRaine into one emulator.
To play NeoGeo CD games you need neocd.bin (or neocd.zip), which is the neocd
bios, to be in the (neo)raine's data directory:
%{_gamesdatadir}/raine .

%files -f %{name}.lang
%doc %{name}.txt %{name}.lyx
%{_gamesbindir}/%{name}
%{_gamesbindir}/%{name}-savegame-converter
%dir %{_gamesdatadir}/%{name}/
%{_gamesdatadir}/%{name}/cheats.cfg
%{_gamesdatadir}/%{name}/debug_dips.txt
%{_gamesdatadir}/%{name}/command.dat
%{_gamesdatadir}/%{name}/hiscore.dat
%{_gamesdatadir}/%{name}/history.dat
# Ex-neocd files
%{_gamesdatadir}/%{name}/neocheats.cfg
%{_gamesdatadir}/%{name}/shots.pl
%{_gamesdatadir}/%{name}/bitmaps
%{_gamesdatadir}/%{name}/blend
%{_gamesdatadir}/%{name}/fonts
%{_gamesdatadir}/%{name}/roms
%{_gamesdatadir}/%{name}/locale
%{_gamesdatadir}/%{name}/scripts
%{_gamesdatadir}/%{name}/shaders
%{_datadir}/applications/%{name}.desktop
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%{_datadir}/pixmaps/%{name}.png

#----------------------------------------------------------------------------

%package artwork
Summary:	Artwork for Raine
Group:		Emulators
Requires:	raine

%description artwork
Artwork for Raine. These files are pictures used mainly to fill the ugly
black borders in vertical games.

%files artwork
%doc raine.txt
%{_gamesdatadir}/raine/artwork

#----------------------------------------------------------------------------

%package emudx2
Summary:	Files to enhance emulation of old arcade games in raine
Group:		Emulators
Requires:	raine

%description emudx2
Files to enhance emulation of old arcade games. Donkey Kong, Frogger,
Galaxian, Pac-Man and Ms. Pac-Man are suported.
It requires the roms to be enhanced and the raine emulator.

%files emudx2
%doc raine.txt
%{_gamesdatadir}/raine/emudx

#----------------------------------------------------------------------------

%prep
%setup -q
%setup -q -T -D -a 1 -a 2 -a 6 -a 8 -a 9
7za x -y %{SOURCE3}
7za x -y %{SOURCE7}
7za x -y %{SOURCE10}
7za x -y %{SOURCE11}

%patch0 -p1


%build
%ifarch x86_64
rm -f cpuinfo
export OSTYPE
%make NO_ASM=1
# Build also the savegame converter - 32bit stuff only
make NO_ASM=1 converter
%else
%if !%{build_optimization}
rm -f cpuinfo
echo "_MARCH=-march=i586 -mtune=pentiumpro" > cpuinfo
echo "CPU=pentiumpro" >> cpuinfo
%else
rm -f cpuinfo
%endif
export OSTYPE
%make
# Build also the savegame converter
make converter
%endif


%install

%makeinstall_std NO_ASM=1


# Install history, command, hiscore...
install -D -m 644 history.dat %{buildroot}%{_gamesdatadir}/%{name}/history.dat
install -D -m 644 command.dat %{buildroot}%{_gamesdatadir}/%{name}/command.dat
install -D -m 644 hiscore.dat %{buildroot}%{_gamesdatadir}/%{name}/hiscore.dat
install -D -m 644 config/cheats.cfg %{buildroot}%{_gamesdatadir}/%{name}/cheats.cfg
install -D -m 644 config/neocheats.cfg %{buildroot}%{_gamesdatadir}/%{name}/neocheats.cfg

# Install the savegame converter
install -m 755 converter %{buildroot}%{_gamesbindir}/%{name}-savegame-converter

# Install icons
install -D -m 644 Raine48x48.png %{buildroot}%{_liconsdir}/%{name}.png
install -D -m 644 Raine32X32.png %{buildroot}%{_iconsdir}/%{name}.png
install -D -m 644 Raine16X16.png %{buildroot}%{_miconsdir}/%{name}.png

# Install .desktop file
desktop-file-install --vendor="" \
	--remove-key="Encoding" \
	--dir %{buildroot}%{_datadir}/applications/ \
	%{buildroot}%{_datadir}/applications/*

# Install artwork
mkdir -p %{buildroot}%{_gamesdatadir}/%{name}/artwork
install -m 644 %{artwork_files} %{buildroot}%{_gamesdatadir}/%{name}/artwork

# Install emudx stuff
install -d -m 755 %{buildroot}%{_gamesdatadir}/%{name}/emudx
install -m 644 %{emudx_files} %{buildroot}%{_gamesdatadir}/%{name}/emudx

# Install blend files
install -d -m 755 %{buildroot}%{_gamesdatadir}/%{name}/blend
install -m 644 blend/*.bld %{buildroot}%{_gamesdatadir}/%{name}/blend

# Install screenshot perl script
install -D -m 755 %{SOURCE5} %{buildroot}%{_gamesdatadir}/%{name}/shots.pl

%find_lang %{name}

%clean
rm -rf %{buildroot}
rm -rf $RPM_BUILD_DIR/%{name}-%{version}


%changelog

* Fri Jun 04 2021 Agent Smith <ruidobranco@yahoo.com.br>  0.91.15b-1pclos2021.rpm
- Created the package raine, with latest sources. 

